/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.abien.toplinkessentials.test;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author adam-bien.com
 */
public class WeakCacheEntityTest {
    private EntityManager entityManager;
    private EntityTransaction entityTransaction;
    @Before
    public void setUp() throws Exception {
        EntityManagerFactory entityManagerFactory = Persistence.createEntityManagerFactory("WeakTest");
        this.entityManager = entityManagerFactory.createEntityManager();
        this.entityTransaction = this.entityManager.getTransaction();
        this.entityTransaction.begin();
        this.entityManager.persist(new WeakCacheEntity("hallo", "some content"));
        this.entityTransaction.commit();
    }


    @Test
    public void testWeakCache() {
        this.entityTransaction.begin();
        this.entityManager.find(WeakCacheEntity.class, "hallo");
        System.gc();
        this.entityManager.find(WeakCacheEntity.class, "hallo");
        this.entityTransaction.commit();
    }

}